#include "include.h"

PRIVATE void putfont8(char *vram, int xsize, int x, int y, char c, char *font)
{
    int i;
    char *p, d;
    for (i = 0; i < 16; i++) {
        p = vram + (y + i) * xsize + x;
        d = font[i];
        if ((d & 0x80) != 0) { p[0] = c; }
        if ((d & 0x40) != 0) { p[1] = c; }
        if ((d & 0x20) != 0) { p[2] = c; }
        if ((d & 0x10) != 0) { p[3] = c; }
        if ((d & 0x08) != 0) { p[4] = c; }
        if ((d & 0x04) != 0) { p[5] = c; }
        if ((d & 0x02) != 0) { p[6] = c; }
        if ((d & 0x01) != 0) { p[7] = c; }
    }
}

PRIVATE void newline()
{
    y += 16;
    x = 0;
}

PRIVATE void scroll()
{
    if (x == xsize + 8) {
        y += 16;
        x = 0;
        if (y == ysize) {
            y = ysize - 16;
            for (int i = 0; i < ysize; i++) {
                for (int j = 0; j < xsize; j++) {
                    vram[j + i * xsize] = vram[j + (i + 16) * xsize];
                }
            }
        }
        if (y == ysize - 8) {
            y = ysize - 16;
            for (int i = 0; i < ysize; i++) {
                for (int j = 0; j < xsize; j++) {
                    vram[j + i * xsize] = vram[j + (i + 8) * xsize];
                }
            }
        }
    }
}

PRIVATE void backspace()
{
    x -= 8;
    if (x == -8) {
        x = xsize - 8;
        if (y != 0) y -= 16;
    } else
    draw_rect(x, y, x + 8, y + 16, COL8_000000);
}

PUBLIC void put_char(char c)
{
    char *font = hankaku + c * 16;
    if (c == '\n') newline();
    else if (c == '\b') backspace();
    else putfont8(vram, xsize, (x += 8) - 8, y, COL8_FFFFFF, font);
    scroll();
}

PUBLIC void put_str(const char *str)
{
    for (; *str; str++) put_char(*str);
}

PUBLIC void put_int(int input)
{
    char output[16];
    itoa(output, input);
    put_str(output);
}