#include "include.h"

PUBLIC void fifo_init(FIFO32 *fifo, int size, u32 *buf)
{
    fifo->size = size;
    fifo->buf = buf;
    fifo->free = size;
    fifo->flags = 0;
    fifo->p = 0;
    fifo->q = 0;
    return;
}

PUBLIC int fifo_put(FIFO32 *fifo, u32 data)
{
    if (fifo->free == 0) {
        fifo->flags |= FLAGS_OVERRUN;
        return -1;
    }
    fifo->buf[fifo->p] = data;
    fifo->p++;
    if (fifo->p == fifo->size) fifo->p = 0;
    fifo->free--;
    return 0;
}

PUBLIC u32 fifo_get(FIFO32 *fifo)
{
    u32 data;
    if (fifo->free == fifo->size) return -1;
    data = fifo->buf[fifo->q];
    fifo->q++;
    if (fifo->q == fifo->size) fifo->q = 0;
    fifo->free++;
    return data;
}

PUBLIC int fifo_status(FIFO32 *fifo)
{
    return fifo->size - fifo->free;
}