#include "include.h"

PUBLIC enum intr_status intr_enable()
{
    enum intr_status old_status;
    if (INTR_ON == intr_get_status()) {
        old_status = INTR_ON;
        return old_status;
    } else {
        old_status = INTR_OFF;
        enable_int();
        return old_status;
    }
}

PUBLIC enum intr_status intr_disable()
{
    enum intr_status old_status;
    if (INTR_ON == intr_get_status()) {
        old_status = INTR_ON;
        disable_int();
        return old_status;
    } else {
        old_status = INTR_OFF;
        return old_status;
    }
}

PUBLIC enum intr_status intr_get_status()
{
    u32 eflags = load_eflags();
    return (eflags & 0x200) ? INTR_ON : INTR_OFF;
}

PUBLIC enum intr_status intr_set_status(enum intr_status status)
{
    return status & INTR_ON ? intr_enable() : intr_disable();
}
