#include "include.h"

PUBLIC void memset(void *dest, u8 value, int size)
{
    assert(dest != NULL);
    u8 *dst = (u8 *) dest;
    while (size-- > 0) *dst++ = value;
}

PUBLIC void memcpy(void *dest, void *src, int size)
{
    assert(dest != NULL && src != NULL);
    u8 *dst = (u8 *) dest;
    u8 *source = (u8 *) src;
    while (size-- > 0) *dst++ = *source++;
}

PUBLIC int memcmp(void *a_, void *b_, int size)
{
    char *a = (char *) a_;
    char *b = (char *) b_;
    assert(a != NULL || b != NULL);
    while (size-- > 0) {
        if (*a != *b) return *a > *b ? 1 : -1;
        a++;
        b++;
    }
    return 0;
}

PUBLIC char *strcpy(char *dest, char *src)
{
    assert(dest != NULL && src != NULL);
    char *r = dest;
    while ((*dest++ = *src++));
    return r;
}

PUBLIC u32 strlen(char *str)
{
    assert(str != NULL);
    char *p = str;
    while (*p++);
    return (p - str - 1);
}

PUBLIC int strcmp(char *a, char *b)
{
    assert(a != NULL && b != NULL);
    while (*a != 0 && *a == *b) {
        a++;
        b++;
    }
    return *a < *b ? -1 : *a > *b;
}

PUBLIC char *strchr(char *str, char ch)
{
    assert(str != NULL);
    while (*str) {
        if (*str == ch) return (char *) str;
        str++;
    }
    return NULL;
}

PUBLIC char *strrchr(char *str, char ch)
{
    assert(str != NULL);
    char *last_char = NULL;

    while (*str != 0) {
        if (*str == ch) last_char = str;
        str++;
    }

    return (char *) last_char;
}

PUBLIC char *strcat(char *dest, char *src)
{
    assert(dest != NULL && src != NULL);
    char *str = dest;
    while (*str++);
    --str;
    while ((*str++ == *src++));
    return dest;
}

PUBLIC int strchrs(char *str, char ch)
{
    assert(str != NULL);
    int ch_cnt = 0;
    char *p = str;
    while (*p != 0) {
        if (*p == ch) ch_cnt++;
        p++;
    }
    return ch_cnt;
}
